function AlbumlistAssistant(albumlist,type){
    this.albumlist = albumlist
	this.type=type
    
}

AlbumlistAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.list = {
        items: []
    }
    var pic;
	
	if (this.type == 1) {
		this.offset = this.albumlist.albumList.length
		for (var i = 0; i < this.albumlist.albumList.length; i++) {
			if (this.albumlist.albumList[i].pic_big.indexOf("http") != -1) 
				pic = this.albumlist.albumList[i].pic_big
			else 
				pic = "images/def_cov.png"
			this.list.items[i] = {
				img: pic,
				title: this.albumlist.albumList[i].title,
				author: this.albumlist.albumList[i].author,
				id: this.albumlist.albumList[i].album_id
			
			
			}
		}
	}
	else {
		if (this.albumlist.pic_big.indexOf("http") != -1) 
			pic = this.albumlist.pic_big
		else 
			pic = "images/def_cov.png"
		this.list.items[0] = {
			img: pic,
			title: this.albumlist.title,
			author: "",
			id: this.albumlist.album_id
		}
	}
    
    this.controller.setupWidget('albumlist', {
        itemTemplate: 'albumlist/albumlist-row',
        listTemplate: "albumlist/albumlist-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.list);
    
    this.albumListTap = this.albumListTap.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.addMoreAlbum = this.addMoreAlbum.bind(this)
    
    this.controller.get('right').hide()
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: true
    }
    
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    Mojo.Event.listen(this.controller.get('albumlist'), Mojo.Event.listTap, this.albumListTap);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
    Mojo.Event.listen(this.controller.get('add'), Mojo.Event.tap, this.addMoreAlbum);
    
};
AlbumlistAssistant.prototype.addMoreAlbum = function(event){
    event.stop()
	if(this.type!=1)
		return;
    if (this.list.items.length >= 150) 
        this.list.items = []
    this.spinnerModel.spinning0 = true;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').show();
    var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.album.getList&limit=30&area=0&order=0&style=0&is_recommend=1&format=json&offset=" + this.offset
    var myAjax = new Ajax.Request(url, {
        method: 'GET',
        onComplete: function(rtn){
            if (rtn.status == 200) {
                var info = Mojo.parseJSON(rtn.responseText)
                var len = this.list.items.length
				this.offset+=info.albumList.length
                for (var i = 0; i < info.albumList.length; i++) {
                    if (info.albumList[i].pic_big.indexOf("http") != -1) 
                        pic = info.albumList[i].pic_big
                    else 
                        pic = "images/def_cov.png"
                    this.list.items[len + i] = {
                        img: pic,
                        title: info.albumList[i].title,
                        author: info.albumList[i].author,
                        id: info.albumList[i].album_id
                    
                    
                    }
                }
                this.controller.modelChanged(this.model)
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
            }
            
            
        }
.bind(this)        ,
        onFailure: function(rtn){
            this.spinnerModel.spinning0 = false;
            this.controller.modelChanged(this.spinnerModel);
            this.controller.get('spinnerCont').hide();
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "出错,请稍后重试",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
.bind(this)
    });
    
};

AlbumlistAssistant.prototype.albumListTap = function(event){
    this.spinnerModel.spinning0 = true;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').show();
    var item = event.item
    var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.album.getAlbumInfo&format=json&album_id=" + item.id
    var myAjax = new Ajax.Request(url, {
        method: 'GET',
        onComplete: function(rtn){
            if (rtn.status == 200) {
                var info = Mojo.parseJSON(rtn.responseText)
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.stageController.pushScene("albuminfo", info)
            }
            
            
        }
.bind(this)        ,
        onFailure: function(rtn){
            this.spinnerModel.spinning0 = false;
            this.controller.modelChanged(this.spinnerModel);
            this.controller.get('spinnerCont').hide();
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "出错,请稍后重试",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
.bind(this)
    });
    
    
    
    
    
};

AlbumlistAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};





AlbumlistAssistant.prototype.activate = function(event){

    if (playstatus != 0) 
        this.controller.get('right').show()
    
};

AlbumlistAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

AlbumlistAssistant.prototype.cleanup = function(event){

};
