function ArtistAlbumlistAssistant(albumlist,item){
    this.albumlist = albumlist
	this.item=item
    
}

ArtistAlbumlistAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
	this.controller.get('cover').src = this.item.img
    this.controller.get('artist_name').update(this.item.author)
    this.controller.get('song_num').update("专辑数: " + this.item.album_num)
    this.list = {
        items: []
    }
    var pic;
	this.offset=this.albumlist.albumlist.length
    for (var i = 0; i < this.albumlist.albumlist.length; i++) {
        if (this.albumlist.albumlist[i].pic_big.indexOf("http") != -1) 
            pic = this.albumlist.albumlist[i].pic_big
        else 
            pic = "images/def_cov.png"
        this.list.items[i] = {
            img: pic,
            title: this.albumlist.albumlist[i].title,
            author: this.albumlist.albumlist[i].author,
            id: this.albumlist.albumlist[i].album_id
        
        
        }
    }
    
    this.controller.setupWidget('albumlist', {
        itemTemplate: 'artist-albumlist/albumlist-row',
        listTemplate: "artist-albumlist/albumlist-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.list);
    
    this.albumListTap = this.albumListTap.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.addMoreAlbum = this.addMoreAlbum.bind(this)
    
    this.controller.get('right').hide()
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: true
    }
    
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    Mojo.Event.listen(this.controller.get('albumlist'), Mojo.Event.listTap, this.albumListTap);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
    Mojo.Event.listen(this.controller.get('add'), Mojo.Event.tap, this.addMoreAlbum);
    
};
ArtistAlbumlistAssistant.prototype.addMoreAlbum = function(event){
    event.stop()
	if (this.offset < this.item.album_num) {
		if (this.list.items.length >= 150) 
			this.list.items = []
		this.spinnerModel.spinning0 = true;
		this.controller.modelChanged(this.spinnerModel);
		this.controller.get('spinnerCont').show();
		var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.artist.getAlbumList&format=json&tinguid="+this.item.id+"&order=1&limits=30&offset="+this.offset
		var myAjax = new Ajax.Request(url, {
			method: 'GET',
			onComplete: function(rtn){
				if (rtn.status == 200) {
					var info = Mojo.parseJSON(rtn.responseText)
					var len = this.list.items.length
					this.offset += info.albumlist.length
					for (var i = 0; i < info.albumlist.length; i++) {
						if (info.albumlist[i].pic_big.indexOf("http") != -1) 
							pic = info.albumlist[i].pic_big
						else 
							pic = "images/def_cov.png"
						this.list.items[len + i] = {
							img: pic,
							title: info.albumlist[i].title,
							author: info.albumlist[i].author,
							id: info.albumlist[i].album_id
						
						
						}
					}
					this.controller.modelChanged(this.model)
					this.spinnerModel.spinning0 = false;
					this.controller.modelChanged(this.spinnerModel);
					this.controller.get('spinnerCont').hide();
				}
				
				
			}
.bind(this)			,
			onFailure: function(rtn){
				this.spinnerModel.spinning0 = false;
				this.controller.modelChanged(this.spinnerModel);
				this.controller.get('spinnerCont').hide();
				this.controller.showAlertDialog({
					onChoose: function(value){
					},
					title: $L("提示"),
					message: "出错,请稍后重试",
					choices: [{
						label: $L('OK'),
						value: "ok",
						type: 'affirmative'
					}]
				});
			}
.bind(this)
		});
	}
    
};

ArtistAlbumlistAssistant.prototype.albumListTap = function(event){
    this.spinnerModel.spinning0 = true;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').show();
    var item = event.item
    var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.album.getAlbumInfo&format=json&album_id=" + item.id
    var myAjax = new Ajax.Request(url, {
        method: 'GET',
        onComplete: function(rtn){
            if (rtn.status == 200) {
                var info = Mojo.parseJSON(rtn.responseText)
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.stageController.pushScene("albuminfo", info)
            }
            
            
        }
.bind(this)        ,
        onFailure: function(rtn){
            this.spinnerModel.spinning0 = false;
            this.controller.modelChanged(this.spinnerModel);
            this.controller.get('spinnerCont').hide();
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "出错,请稍后重试",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
.bind(this)
    });
    
    
    
    
    
};

ArtistAlbumlistAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};





ArtistAlbumlistAssistant.prototype.activate = function(event){

    if (playstatus != 0) 
        this.controller.get('right').show()
    
};

ArtistAlbumlistAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

ArtistAlbumlistAssistant.prototype.cleanup = function(event){

};
