function ArtistSonglistAssistant(info, item){
    this.info = info
    this.item = item
}

ArtistSonglistAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.controller.get('cover').src = this.item.img
    this.controller.get('artist_name').update(this.item.author)
    this.controller.get('song_num').update("歌曲数: " + this.item.song_num)
    var songlist = this.info.songlist
    this.dlItem = null;
    
    this.list = {
        items: []
    }
    this.downloadStatus = false;
    this.offset = songlist.length
    for (var i = 0; i < songlist.length; i++) {
        this.list.items[i] = {
            name: songlist[i].title,
            id: songlist[i].song_id,
            author: songlist[i].author,
            thumb: "",
            activeClass: "",
            progress_id: songlist[i].song_id,
            updateClass: "show",
            warningClass: "",
            waitingClass: "",
            downloadfinish: false,
            downloadticket: 0,
            lyricUrl: "",
            url: ""
        
        }
    }
    this.controller.setupWidget('songlist', {
        itemTemplate: 'artist-songlist/songlist-row',
        listTemplate: "artist-songlist/songlist-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.list);
    this.songlistTap = this.songlistTap.bind(this)
    this.downloadTap = this.downloadTap.bind(this)
    this.downloadSuccess = this.downloadSuccess.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.addMoreSong = this.addMoreSong.bind(this)
    this.controller.get('right').hide()
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: true
    }
    
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    Mojo.Event.listen(this.controller.get('songlist'), Mojo.Event.listTap, this.songlistTap);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
    Mojo.Event.listen(this.controller.get('add'), Mojo.Event.tap, this.addMoreSong);
};

ArtistSonglistAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};

ArtistSonglistAssistant.prototype.addMoreSong = function(event){
    event.stop()
    if (this.offset < this.item.song_num) {
        if (this.list.items.length >= 150) 
            this.list.items = []
        this.spinnerModel.spinning0 = true;
        this.controller.modelChanged(this.spinnerModel);
        this.controller.get('spinnerCont').show();
        var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.artist.getSongList&format=json&tinguid=" + this.item.id + "&limits=50&order=1&offset=" + this.offset
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: function(rtn){
                if (rtn.status == 200) {
                    var info = Mojo.parseJSON(rtn.responseText)
                    var songlist = info.songlist
                    var len = this.list.items.length
                    this.offset += songlist.length
                    for (var i = 0; i < songlist.length; i++) {
                        this.list.items[len + i] = {
                            name: songlist[i].title,
                            id: songlist[i].song_id,
                            author: songlist[i].author,
                            thumb: songlist[i].pic_big,
                            activeClass: "",
                            progress_id: songlist[i].song_id,
                            updateClass: "show",
                            warningClass: "",
                            waitingClass: "",
                            downloadfinish: false,
                            downloadticket: 0,
                            lyricUrl: "",
                            url: ""
                        
                        }
                    }
                    this.controller.modelChanged(this.model)
                    this.spinnerModel.spinning0 = false;
                    this.controller.modelChanged(this.spinnerModel);
                    this.controller.get('spinnerCont').hide();
                }
                
                
            }
.bind(this)            ,
            onFailure: function(rtn){
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
        
    }
};

ArtistSonglistAssistant.prototype.songlistTap = function(event){
    event.stop()
    var element = event.originalEvent.target || event.target
    var item = event.item
    
    
    if (element.hasClassName("update-button")) {
        if (this.downloadStatus) 
            return;
        this.downloadStatus = true
        this.dlItem = item
        var url
        if (islogin && dquality == 2) 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfos&bduss=" + bduss + "&format=json&songid=" + item.id + "&from=android&version=2.4.1"
        else 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfo&bduss=empty&format=json&songid=" + item.id
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: this.downloadTap,
            onFailure: function(rtn){
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
        
    }
    else {
        playlist = this.list;
        playidx = this.model.items.indexOf(item);
        playstatus = 4;
        this.controller.stageController.pushScene("nowplaying", this.item.author)
    }
    
};

ArtistSonglistAssistant.prototype.downloadTap = function(rtn){
    if (rtn.status == 200) {
        var info = Mojo.parseJSON(rtn.responseText)
        var bit = info.songinfo.bitrate.split(",")
        var idx = 0;
        if (bit.length == 1) 
            idx = 0
        else {
            for (var i = bit.length - 1; i > 0; i--) {
                if (parseInt(bit[i]) >= parseInt(bit[i - 1])) {
                    idx = i;
                    break;
                }
                
            }
            
        }
        
        var file_url
        if (islogin && dquality == 2) 
            file_url = info.songurl.url[idx].file_link
        else 
            file_url = info.songurl.url[0].file_link
        if (file_url != null) {
            this.dlItem.updateClass = ""
            this.dlItem.waitingClass = "show"
            this.dlItem.activeClass = "active"
            this.dlItem.url = file_url;
            this.dlItem.lyricUrl = info.songinfo.lrclink;
            this.dlItem.thumb = info.songinfo.pic_big
            this.dlItem.author = info.songinfo.author
            
            this.controller.modelChanged(this.model)
            this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
                method: 'download',
                parameters: {
                    target: file_url,
                    targetDir: "/media/internal/ting/",
                    targetFilename: info.songinfo.title + "_" + info.songinfo.author + "." + info.songurl.url[0].file_extension,
                    keepFilenameOnRedirect: true,
                    subscribe: true,
                    canHandlePause: true
                },
                onSuccess: this.downloadSuccess,
                onFailure: function(e){
                    this.controller.showAlertDialog({
                        onChoose: function(value){
                        },
                        title: $L("提示"),
                        message: "下载出错",
                        choices: [{
                            label: $L('OK'),
                            value: "ok",
                            type: 'affirmative'
                        }]
                    });
                }
            });
        }
        
        
    }
};


ArtistSonglistAssistant.prototype.downloadSuccess = function(resp){
    if (resp.completed) {
        if (resp.completionStatusCode == 200) {
            this.downloadStatus = false;
            this.dlItem.updateClass = ""
            this.dlItem.activeClass = ""
            this.dlItem.waitingClass = ""
            this.dlItem.finishClass = "show"
            this.dlItem.downloadfinish = true;
            this.controller.get(this.dlItem.progress_id).style.width = "0%"
            this.controller.modelChanged(this.model)
            
        }
        
    }
    else 
        if (resp.aborted) {
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "下载中断",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
        else {
            var index = this.model.items.indexOf(this.dlItem)
            this.dlItem.downloadticket = resp.ticket
            
            this.dlItem.progress = (resp.amountReceived / resp.amountTotal) * 100
            this.controller.get(this.dlItem.progress_id).style.width = (resp.amountReceived / resp.amountTotal) * 100 + "%"
        //this.controller.modelChanged(this.model)
        //this.controller.get('albumlist').mojo.noticeUpdatedItems(index, this.dlItem)
        
        
        }
};

ArtistSonglistAssistant.prototype.activate = function(event){
    if (playstatus != 0) 
        this.controller.get('right').show()
};

ArtistSonglistAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

ArtistSonglistAssistant.prototype.cleanup = function(event){
    Mojo.Event.stopListening(this.controller.get('songlist'), Mojo.Event.listTap, this.songlistTap);
};
