function CollectionAssistant(collectionInfo){
    this.collection = collectionInfo
    
}

CollectionAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.list = {
        items: []
    }
    var pic;
    for (var i = 0; i < this.collection.albumList.length; i++) {
        if (this.collection.albumList[i].pic.indexOf("http") != -1) 
            pic = this.collection.albumList[i].pic
        else 
            pic = "images/def_cov.png"
        this.list.items[i] = {
            img: pic,
            t: this.collection.albumList[i].name,
            code: this.collection.albumList[i].code
        
        
        }
    }
    
    this.controller.setupWidget('collection', {
        itemTemplate: 'collection/collection-row',
        listTemplate: "collection/collection-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.list);
    
    this.collectionListTap = this.collectionListTap.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.addMoreCollection = this.addMoreCollection.bind(this)
    
    this.controller.get('right').hide()
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: true
    }
    
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    Mojo.Event.listen(this.controller.get('collection'), Mojo.Event.listTap, this.collectionListTap);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
    Mojo.Event.listen(this.controller.get('add'), Mojo.Event.tap, this.addMoreCollection);
    
};
CollectionAssistant.prototype.addMoreCollection = function(event){
    event.stop()
    if (this.list.items.length < this.collection.total && this.list.items.length < 120) {
        this.spinnerModel.spinning0 = true;
        this.controller.modelChanged(this.spinnerModel);
        this.controller.get('spinnerCont').show();
        var url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.diy.getOfficialDiyList&format=json&rn=30&pn=" + this.list.items.length
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: function(rtn){
                if (rtn.status == 200) {
                    var info = Mojo.parseJSON(rtn.responseText)
                    var len = this.list.items.length
                    for (var i = 0; i < info.albumList.length; i++) {
                        if (info.albumList[i].pic.indexOf("http") != -1) 
                            pic = info.albumList[i].pic
                        else 
                            pic = "images/def_cov.png"
                        this.list.items[len + i] = {
                            img: pic,
                            t: info.albumList[i].name,
                            code: info.albumList[i].code
                        
                        
                        }
                    }
                    this.controller.modelChanged(this.model)
                    this.spinnerModel.spinning0 = false;
                    this.controller.modelChanged(this.spinnerModel);
                    this.controller.get('spinnerCont').hide();
                }
                
                
            }
.bind(this)            ,
            onFailure: function(rtn){
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
    }
};

CollectionAssistant.prototype.collectionListTap = function(event){
    this.spinnerModel.spinning0 = true;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').show();
    var item = event.item
	var url="http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.diy.getSongFromOfficalList&format=json&code="+item.code
	  var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: function(rtn){
                if (rtn.status == 200) {
                    var info = Mojo.parseJSON(rtn.responseText)
                    this.spinnerModel.spinning0 = false;
                    this.controller.modelChanged(this.spinnerModel);
                    this.controller.get('spinnerCont').hide();
					this.controller.stageController.pushScene("collectioninfo", info)
                }
                
                
            }
.bind(this)            ,
            onFailure: function(rtn){
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
    
   
    
    
    
};

CollectionAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};





CollectionAssistant.prototype.activate = function(event){

    if (playstatus != 0) 
        this.controller.get('right').show()
    
};

CollectionAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

CollectionAssistant.prototype.cleanup = function(event){
 
};
