function CollectioninfoAssistant(info){
    this.info = info
}

CollectioninfoAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.controller.get('cover').src = this.info.pic
    this.controller.get('title').update(this.info.name)
    if (this.info.desc.length > 80) 
        this.controller.get('desc').update(this.info.desc.substr(0, 80) + "...")
    else 
        this.controller.get('desc').update(this.info.desc)
    this.controller.get('create_time').update("创建时间: " + this.info.createTime)
    var songlist = this.info.list
    this.dlItem = null;
    
    this.album = {
        items: []
    }
    this.downloadStatus = false;
    for (var i = 0; i < songlist.length; i++) {
        this.album.items[i] = {
            name: songlist[i].title,
            id: songlist[i].song_id,
            author: songlist[i].author,
            thumb: "",
            activeClass: "",
            progress_id: songlist[i].song_id,
            updateClass: "show",
            warningClass: "",
            waitingClass: "",
            downloadfinish: false,
            downloadticket: 0,
            lyricUrl: "",
            url: ""
        
        }
    }
    this.controller.setupWidget('collectionlist', {
        itemTemplate: 'collectioninfo/collectioninfo-row',
        listTemplate: "collectioninfo/collectioninfo-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.album);
    this.songlistTap = this.songlistTap.bind(this)
    this.downloadTap = this.downloadTap.bind(this)
    this.downloadSuccess = this.downloadSuccess.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.controller.get('right').hide()
    Mojo.Event.listen(this.controller.get('collectionlist'), Mojo.Event.listTap, this.songlistTap);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
};

CollectioninfoAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};

CollectioninfoAssistant.prototype.songlistTap = function(event){
    event.stop()
    var element = event.originalEvent.target || event.target
    var item = event.item
    
    
    if (element.hasClassName("update-button")) {
        if (this.downloadStatus) 
            return this.downloadStatus = true
        this.dlItem = item
        var url
        if (islogin && dquality == 2) 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfos&bduss=" + bduss + "&format=json&songid=" + item.id + "&from=android&version=2.4.1"
        else 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfo&bduss=empty&format=json&songid=" + item.id
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: this.downloadTap,
            onFailure: function(rtn){
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
        
    }
    else {
        playlist = this.album;
        playidx = this.model.items.indexOf(item);
        playstatus = 4;
        this.controller.stageController.pushScene("nowplaying", this.info.name)
    }
    
};

CollectioninfoAssistant.prototype.downloadTap = function(rtn){
    if (rtn.status == 200) {
        var info = Mojo.parseJSON(rtn.responseText)
        var bit = info.songinfo.bitrate.split(",")
        var idx = 0;
        if (bit.length == 1) 
            idx = 0
        else {
            for (var i = bit.length - 1; i > 0; i--) {
                if (parseInt(bit[i]) >= parseInt(bit[i - 1])) {
                    idx = i;
                    break;
                }
                
            }
            
        }
        
        var file_url
        if (islogin && dquality == 2) 
            file_url = info.songurl.url[idx].file_link
        else 
            file_url = info.songurl.url[0].file_link
        if (file_url != null) {
            this.dlItem.updateClass = ""
            this.dlItem.waitingClass = "show"
            this.dlItem.activeClass = "active"
            this.dlItem.url = file_url;
            this.dlItem.lyricUrl = info.songinfo.lrclink;
            this.dlItem.thumb = info.songinfo.pic_big
            this.dlItem.author = info.songinfo.author
            
            this.controller.modelChanged(this.model)
            this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
                method: 'download',
                parameters: {
                    target: file_url,
                    targetDir: "/media/internal/ting/",
                    targetFilename: info.songinfo.title + "_" + info.songinfo.author + "." + info.songurl.url[0].file_extension,
                    keepFilenameOnRedirect: true,
                    subscribe: true,
                    canHandlePause: true
                },
                onSuccess: this.downloadSuccess,
                onFailure: function(e){
                    this.controller.showAlertDialog({
                        onChoose: function(value){
                        },
                        title: $L("提示"),
                        message: "下载出错",
                        choices: [{
                            label: $L('OK'),
                            value: "ok",
                            type: 'affirmative'
                        }]
                    });
                }
            });
        }
        
        
    }
};


CollectioninfoAssistant.prototype.downloadSuccess = function(resp){
    if (resp.completed) {
        if (resp.completionStatusCode == 200) {
            this.downloadStatus = false;
            this.dlItem.updateClass = ""
            this.dlItem.activeClass = ""
            this.dlItem.waitingClass = ""
            this.dlItem.finishClass = "show"
            this.dlItem.downloadfinish = true;
            this.controller.get(this.dlItem.progress_id).style.width = "0%"
            this.controller.modelChanged(this.model)
            
        }
        
    }
    else 
        if (resp.aborted) {
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "下载中断",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
        else {
            var index = this.model.items.indexOf(this.dlItem)
            this.dlItem.downloadticket = resp.ticket
            
            this.dlItem.progress = (resp.amountReceived / resp.amountTotal) * 100
            this.controller.get(this.dlItem.progress_id).style.width = (resp.amountReceived / resp.amountTotal) * 100 + "%"
        //this.controller.modelChanged(this.model)
        //this.controller.get('albumlist').mojo.noticeUpdatedItems(index, this.dlItem)
        
        
        }
};

CollectioninfoAssistant.prototype.activate = function(event){
    if (playstatus != 0) 
        this.controller.get('right').show()
};

CollectioninfoAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

CollectioninfoAssistant.prototype.cleanup = function(event){
    Mojo.Event.stopListening(this.controller.get('collectionlist'), Mojo.Event.listTap, this.songlistTap);
};
