function NowplayingAssistant(title){
    this.idx = playidx;
    this.title = title
    playtitle = title
}

NowplayingAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.controller.get('title').update(this.title)
    this.controller.get('name').update(playlist.items[this.idx].name)
    this.controller.get('author').update(playlist.items[this.idx].author)
    this.percent = 0;
    this.controller.setupWidget("progress", this.sliderAttributes = {
        minValue: 0,
        maxValue: 100
    }, this.sliderModel = {
        value: this.percent,
        disabled: false
    });
    
    this.play = this.play.bind(this)
    this.handleSceneActive = this.handleSceneActive.bind(this)
    this.timefomat = this.timefomat.bind(this)
    this.playAnotherSong = this.playAnotherSong.bind(this)
    this.handlePauseEvent = this.handlePauseEvent.bind(this)
    this.handlePlayandPauseButtonTapped = this.handlePlayandPauseButtonTapped.bind(this)
    this.handleModeChange = this.handleModeChange.bind(this)
    this.handlePrevSong = this.handlePrevSong.bind(this)
    this.handleNextSong = this.handleNextSong.bind(this)
    this.handleDownload = this.handleDownload.bind(this)
    this.downloadResult = this.downloadResult.bind(this)
    this.downloadTap = this.downloadTap.bind(this)
    this.lyricParse = this.lyricParse.bind(this)
    this.lyricTime = new Array()
    this.lyricContent = new Array()
    this.lyricidx = -1;
    this.lyricStatus = false;
    this.parseLyric = this.parseLyric.bind(this)
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: false
    }
    this.downloadStatus = false;
    
    this.controller.setupWidget('spinner1', this.spinnerLAttrs, this.spinnerModel);
    Mojo.Event.listen(this.controller.get('progress'), Mojo.Event.propertyChange, this.seekSongPosition.bind(this));
    Mojo.Event.listen(this.controller.get('play_pause'), Mojo.Event.tap, this.handlePlayandPauseButtonTapped);
    Mojo.Event.listen(this.controller.get('mode'), Mojo.Event.tap, this.handleModeChange);
    Mojo.Event.listen(this.controller.get('prev'), Mojo.Event.tap, this.handlePrevSong);
    Mojo.Event.listen(this.controller.get('next'), Mojo.Event.tap, this.handleNextSong);
    Mojo.Event.listen(this.controller.get('download'), Mojo.Event.tap, this.downloadTap);
    
    
};

NowplayingAssistant.prototype.handlePrevSong = function(event){
    if (player.currentTime > 8) 
        player.currentTime = 0;
    else {
        player.pause()
        player.src = null
        
        if (playmode == 1) {
            var rand = Math.floor(Math.random() * playlist.items.length) % playlist.items.length
            if (rand == playidx) 
                playidx = (playidx + 1) % playlist.items.length;
            else 
                playidx = rand;
        }
        else {
            if (playidx == 0) 
                playidx = playlist.items.length - 1;
            else 
                playidx = (playidx - 1) % playlist.items.length
            
        }
        this.playAnotherSong()
    }
}

NowplayingAssistant.prototype.downloadTap = function(event){
    event.stop()
    
    if (this.downloadStatus) 
        return;
    this.downloadStatus = true
    var url
    if (islogin && dquality == 2) 
        url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfos&bduss=" + bduss + "&format=json&songid=" + playlist.items[this.idx].id + "&from=android&version=2.4.1"
    else 
        url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfo&bduss=empty&format=json&songid=" + playlist.items[this.idx].id
    var myAjax = new Ajax.Request(url, {
        method: 'GET',
        onComplete: this.handleDownload,
        onFailure: function(rtn){
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "出错,请稍后重试",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
.bind(this)
    });
    
    
    
};



NowplayingAssistant.prototype.handleDownload = function(rtn){
    if (rtn.status == 200) {
        var bannerParams = {
            messageText: "开始下载歌曲:" + playlist.items[this.idx].name,
        
        };
        Mojo.Controller.getAppController().showBanner(bannerParams, {}, "msg");
        var info = Mojo.parseJSON(rtn.responseText)
        var bit = info.songinfo.bitrate.split(",")
        var idx = 0;
        if (bit.length == 1) 
            idx = 0
        else {
            for (var i = bit.length - 1; i > 0; i--) {
                if (parseInt(bit[i]) >= parseInt(bit[i - 1])) {
                    idx = i;
                    break;
                }
                
            }
            
        }
        var file_url
        if (islogin && dquality == 2) 
            file_url = info.songurl.url[idx].file_link
        else 
            file_url = info.songurl.url[0].file_link
        this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
            method: 'download',
            parameters: {
                target: file_url,
                targetDir: "/media/internal/ting/",
                targetFilename: playlist.items[this.idx].name + "_" + playlist.items[this.idx].author + ".mp3",
                keepFilenameOnRedirect: true,
                subscribe: true,
                canHandlePause: true
            },
            onSuccess: this.downloadResult,
            onFailure: function(e){
                this.downloadStatus = false;
                var bannerParams = {
                    messageText: "歌曲下载失败",
                
                };
                Mojo.Controller.getAppController().showBanner(bannerParams, {}, "msg");
            }
        });
    }
}
NowplayingAssistant.prototype.downloadResult = function(resp){
    if (resp.completed) {
        if (resp.completionStatusCode == 200) {
            this.downloadStatus = false;
            var bannerParams = {
                messageText: "歌曲下载完成",
            
            };
            Mojo.Controller.getAppController().showBanner(bannerParams, {}, "msg");
            
        }
        
    }
    else 
        if (resp.aborted) {
            this.downloadStatus = false;
            var bannerParams = {
                messageText: "歌曲下载中断",
            
            };
            Mojo.Controller.getAppController().showBanner(bannerParams, {}, "msg");
        }
    
}

NowplayingAssistant.prototype.handleNextSong = function(event){

    player.pause()
    player.src = null
    
    if (playmode == 1) {
        var rand = Math.floor(Math.random() * playlist.items.length) % playlist.items.length
        if (rand == playidx) 
            playidx = (playidx + 1) % playlist.items.length;
        else 
            playidx = rand;
    }
    else {
    
        playidx = (playidx + 1) % playlist.items.length
    }
    
    this.playAnotherSong()
    
}

NowplayingAssistant.prototype.seekSongPosition = function(event){
    var time = event.value * player.duration / 100
    player.currentTime = time
}



NowplayingAssistant.prototype.handleModeChange = function(event){
    playmode = (playmode) % 4 + 1;
    this.controller.get('mode').src = "images/mode" + playmode + ".png"
    if (playmode == 3) 
        player.loop = true
    else 
        player.loop = false;
}


NowplayingAssistant.prototype.handlePlayandPauseButtonTapped = function(event){
    Mojo.Log.info("Play button tapped:" + playstatus)
    if (playstatus == 1) {
    
        player.pause();
    }
    else 
        if (playstatus == 2) {
            player.play()
        }
        else 
            if (playstatus == 0) {
                this.playAnotherSong()
            }
    
    
}

NowplayingAssistant.prototype.handlePauseEvent = function(){
    this.controller.get('play_pause').src = "images/play.png"
}

NowplayingAssistant.prototype.playAnotherSong = function(){
    this.idx = playidx;
    this.lyricStatus = false;
    curlyc = ""
    this.lyricidx = -1;
    this.lyricTime = []
    this.lyricContent = []
    Mojo.Log.info(playlist.items[this.idx].name + "_" + playlist.items[this.idx].author + "_" + playlist.items[this.idx].id + "_" + this.idx)
    this.controller.get('name').update(playlist.items[this.idx].name)
    this.controller.get('author').update(playlist.items[this.idx].author)
    if (playlist.items[this.idx].thumb.indexOf("http") == -1) 
        this.controller.get('thumb').src = "images/def_cov.png"
    else 
        this.controller.get('thumb').src = playlist.items[this.idx].thumb
    this.controller.get('totaltime').update("00:00")
    this.controller.get('currenttime').update("00:00")
    this.controller.get('lyric1').update(" ")
    this.controller.get('lyric2').update(" ")
    this.controller.get('lyric3').update(" ")
    this.sliderModel.value = 0
    this.controller.modelChanged(this.sliderModel)
    this.play()
    
}

NowplayingAssistant.prototype.lyricParse = function(rtn){
    if (rtn.status == 200) {
        curlyc = rtn.responseText
        var lyric = rtn.responseText.split("[")
        this.lyricTime = []
        this.lyricContent = []
        for (var i = 1; i < lyric.length; i++) {
            var tmp = lyric[i].split("]")
            this.lyricTime[tmp[0].split(".")[0]] = i - 1;
            this.lyricContent[i - 1] = tmp[1]
            
            
        }
        Mojo.Log.info("Lyric length:" + this.lyricContent.length)
        this.controller.get('lyric1').update(" ")
        this.controller.get('lyric2').update(" ")
        this.controller.get('lyric3').update(this.lyricContent[0])
        this.lyricStatus = true;
    }
    
}

NowplayingAssistant.prototype.parseLyric = function(){
    var lyric = curlyc.split("[")
    this.lyricTime = []
    this.lyricContent = []
    for (var i = 1; i < lyric.length; i++) {
        var tmp = lyric[i].split("]")
        this.lyricTime[tmp[0].split(".")[0]] = i - 1;
        this.lyricContent[i - 1] = tmp[1]
        
        
    }
    Mojo.Log.info("Lyric length:" + this.lyricContent.length)
    this.controller.get('lyric1').update(" ")
    this.controller.get('lyric2').update(" ")
    this.controller.get('lyric3').update(this.lyricContent[0])
    this.lyricStatus = true;
    
    
}

NowplayingAssistant.prototype.timefomat = function(val){
    if (isNaN(val)) 
        val = 0;
    var mins = parseInt(String(val / 60));
    if (mins < 10) 
        mins = "0" + String(mins);
    var secs = parseInt(String(val % 60));
    if (secs < 10) 
        secs = "0" + String(secs);
    return mins + ":" + secs;
    
}



NowplayingAssistant.prototype.handleTimeUpdate = function(current, duration){
    //this.controller.get('play_pause').src="images/pause.png"
    var cur = this.timefomat(current)
    this.controller.get('currenttime').update(cur)
    this.controller.get('totaltime').update(this.timefomat(duration))
    this.sliderModel.value = current / duration * 100
    this.controller.modelChanged(this.sliderModel)
    if (this.lyricStatus) {
        if (this.lyricTime[cur] != null) {
            var id = this.lyricTime[cur]
            if (id > 0) 
                this.controller.get('lyric1').update(this.lyricContent[id - 1])
            else 
                this.controller.get('lyric1').update(" ")
            this.controller.get('lyric2').update(this.lyricContent[id])
            if (id + 1 < this.lyricContent.length) 
                this.controller.get('lyric3').update(this.lyricContent[id + 1])
            else 
                this.controller.get('lyric3').update(" ")
            
            
        }
        
    }
    
    
    
}

NowplayingAssistant.prototype.handlePlay = function(){
    this.controller.get('play_pause').src = "images/pause.png"
    playstatus = 1;
    this.spinnerModel.spinning0 = false;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').hide();
    if (!this.lyricStatus) {
        var url = playlist.items[this.idx].lyricUrl
        Mojo.Log.info("Lyric url:" + playlist.items[this.idx].lyricUrl)
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: this.lyricParse,
            onFailure: function(rtn){
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
    }
    
    
}

NowplayingAssistant.prototype.play = function(){

    this.spinnerModel.spinning0 = true;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get('spinnerCont').show();
    
    if (playlist.items[this.idx].url != "") {
        this.controller.get('author').update(playlist.items[this.idx].author)
        if (playlist.items[this.idx].thumb.indexOf("http") == -1) 
            this.controller.get('thumb').src = "images/def_cov.png"
        else 
            this.controller.get('thumb').src = playlist.items[this.idx].thumb
        player.src = playlist.items[this.idx].url
        player.load()
        
    }
    else {
        var url
        if (islogin && lquality == 2) 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfos&bduss=" + bduss + "&format=json&songid=" + playlist.items[this.idx].id + "&from=android&version=2.4.1"
        else 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfo&bduss=empty&format=json&songid=" + playlist.items[this.idx].id
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: function(rtn){
                if (rtn.status == 200) {
                    var info = Mojo.parseJSON(rtn.responseText)
                    var bit = info.songinfo.bitrate.split(",")
                    var idx = 0;
                    if (bit.length == 1) 
                        idx = 0
                    else {
                        for (var i = bit.length - 1; i > 0; i--) {
                            if (parseInt(bit[i]) >= parseInt(bit[i - 1])) {
                                idx = i;
                                break;
                            }
                            
                        }
                        
                    }
                    if (info.songurl.url.length == 0) {
                        playidx = (playidx + 1) % playlist.items.length
                        this.playAnotherSong()
                    }
                    else {
                        if (info.songurl.url[0].file_link.indexOf("null") != -1) {
                            playidx = (playidx + 1) % playlist.items.length
                            this.playAnotherSong()
                        }
                        else {
                            if (islogin && lquality == 2) 
                                playlist.items[this.idx].url = info.songurl.url[idx].file_link;
                            else 
                                playlist.items[this.idx].url = info.songurl.url[0].file_link;
                            playlist.items[this.idx].lyricUrl = info.songinfo.lrclink;
                            playlist.items[this.idx].thumb = info.songinfo.pic_big
                            playlist.items[this.idx].author = info.songinfo.author
                            this.controller.get('author').update(playlist.items[this.idx].author)
                            if (playlist.items[this.idx].thumb.indexOf("http") == -1) 
                                this.controller.get('thumb').src = "images/def_cov.png"
                            else 
                                this.controller.get('thumb').src = playlist.items[this.idx].thumb
                            player.src = playlist.items[this.idx].url
                            player.load()
                        }
                    }
                    
                    
                }
                
                
            }
.bind(this)            ,
            onFailure: function(rtn){
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
    }
};

NowplayingAssistant.prototype.handleSceneActive = function(event){
    //0:stop;1:playing;2:pause;4:stop->play;
    if (playstatus == 0 || playstatus == 2) {
        this.controller.get('play_pause').src = "images/play.png"
        if (playstatus == 2) {
            this.controller.get('currenttime').update(this.timefomat(player.currentTime))
            this.controller.get('totaltime').update(this.timefomat(player.duration))
            if (playlist.items[this.idx].thumb.indexOf("http") == -1) 
                this.controller.get('thumb').src = "images/def_cov.png"
            else 
                this.controller.get('thumb').src = playlist.items[this.idx].thumb
            this.sliderModel.value = player.currentTime / player.duration * 100
            this.controller.modelChanged(this.sliderModel)
            this.parseLyric()
        }
    }
    else 
        if (playstatus == 1) {
            if (playlist.items[this.idx].thumb.indexOf("http") == -1) 
                this.controller.get('thumb').src = "images/def_cov.png"
            else 
                this.controller.get('thumb').src = playlist.items[this.idx].thumb
            this.parseLyric()
            this.controller.get('play_pause').src = "images/pause.png"
        }
        else {
            player.src = null
            this.play()
            
        }
};

NowplayingAssistant.prototype.activate = function(event){

    scenestatus = true;
    this.handleSceneActive()
};

NowplayingAssistant.prototype.deactivate = function(event){

};

NowplayingAssistant.prototype.cleanup = function(event){
    Mojo.Event.stopListening(this.controller.get('progress'), Mojo.Event.propertyChange, this.seekSongPosition.bind(this));
    Mojo.Event.stopListening(this.controller.get('play_pause'), Mojo.Event.tap, this.handlePlayandPauseButtonTapped);
    Mojo.Event.stopListening(this.controller.get('mode'), Mojo.Event.tap, this.handleModeChange);
    Mojo.Event.stopListening(this.controller.get('prev'), Mojo.Event.tap, this.handlePrevSong);
    Mojo.Event.stopListening(this.controller.get('next'), Mojo.Event.tap, this.handleNextSong);
    scenestatus = false;
};
