function SonglistAssistant(songlist, type, content, pages){
    this.type = type
    this.songlist = songlist
    this.content = content
    this.totalpages = pages
    
}


SonglistAssistant.prototype.setup = function(){
    this.controller.document.body.style.backgroundColor = "#f9f9f9";
    this.title = "歌曲列表"
    this.pages = 1;
    if (this.type == 1) 
        this.title = "新歌榜"
    else 
        if (this.type == 2) 
            this.title = "热歌榜"
        else 
            if (this.type == 3) 
                this.title = "新歌速递"
            else 
                if (this.type == 4) 
                    this.title = "歌曲列表"
    
    this.controller.get('title').update(this.title)
    this.dlItem = null;
    
    this.list = {
        items: []
    }
    
    this.downloadStatus = false;
    if (this.type != 4) 
        for (var i = 0; i < this.songlist.length; i++) {
            this.list.items[i] = {
                name: this.songlist[i].title,
                id: this.songlist[i].song_id,
                author: this.songlist[i].author,
                thumb: this.songlist[i].pic_big,
                activeClass: "",
                progress_id: this.songlist[i].song_id,
                updateClass: "show",
                warningClass: "",
                waitingClass: "",
                downloadfinish: false,
                downloadticket: 0,
                lyricUrl: "",
                url: ""
            
            }
        }
    else 
        for (var i = 0; i < this.songlist.length; i++) {
            this.list.items[i] = {
                name: this.songlist[i].title.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                id: this.songlist[i].song_id,
                author: this.songlist[i].author.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                thumb: "",
                activeClass: "",
                progress_id: this.songlist[i].song_id,
                updateClass: "show",
                warningClass: "",
                waitingClass: "",
                downloadfinish: false,
                downloadticket: 0,
                lyricUrl: "",
                url: ""
            
            }
        }
    this.controller.setupWidget('songlist', {
        itemTemplate: 'songlist/songlist-row',
        listTemplate: "songlist/songlist-container",
        initialScrollingDirection: 'up',
        snapToBottomTolerance: 300,
        renderLimit: 150
    }, this.model = this.list);
    this.songlistTap = this.songlistTap.bind(this)
    this.downloadTap = this.downloadTap.bind(this)
    this.downloadSuccess = this.downloadSuccess.bind(this)
    this.addMoreSong = this.addMoreSong.bind(this)
    this.toPlayingScene = this.toPlayingScene.bind(this)
    this.spinnerLAttrs = {
        spinnerSize: Mojo.Widget.spinnerLarge,
        modelProperty: 'spinning0'
    }
    this.spinnerModel = {
        spinning0: false
    }
    
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    if (this.type != 3) 
        this.controller.get('add').show()
    this.controller.get('right').hide()
    Mojo.Event.listen(this.controller.get('songlist'), Mojo.Event.listTap, this.songlistTap);
    Mojo.Event.listen(this.controller.get('add'), Mojo.Event.tap, this.addMoreSong);
    Mojo.Event.listen(this.controller.get('right'), Mojo.Event.tap, this.toPlayingScene);
};

SonglistAssistant.prototype.toPlayingScene = function(){
    this.controller.stageController.pushScene("nowplaying", playtitle)
    
    
    
};

SonglistAssistant.prototype.addMoreSong = function(event){
    event.stop()
    if (this.list.items.length < 150) {
    
        var url
        if (this.type == 1) 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.billboard.billList&type=1&format=json&size=50&offset=" + this.list.items.length
        else 
            if (this.type == 4) {
                if (this.pages < this.totalpages) {
                    this.pages++;
                    url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.search.common&page_size=50&format=json&query=" + this.content + "&page_no=" + this.pages
                }
                else 
                    return;
            }
            else 
                url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.billboard.billList&type=2&format=json&size=50&offset=" + this.list.items.length
        this.spinnerModel.spinning0 = true;
        this.controller.modelChanged(this.spinnerModel);
        this.controller.get('spinnerCont').show();
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: function(rtn){
                if (rtn.status == 200) {
                    var info = Mojo.parseJSON(rtn.responseText)
                    var songlist = info.song_list
                    var len = this.list.items.length
                    if (this.type != 4) 
                        for (var i = 0; i < songlist.length; i++) {
                            this.list.items[len + i] = {
                                name: songlist[i].title,
                                id: songlist[i].song_id,
                                author: songlist[i].author,
                                thumb: songlist[i].pic_big,
                                activeClass: "",
                                progress_id: songlist[i].song_id,
                                updateClass: "show",
                                warningClass: "",
                                waitingClass: "",
                                downloadfinish: false,
                                downloadticket: 0,
                                lyricUrl: "",
                                url: ""
                            
                            }
                        }
                    else 
                        for (var i = 0; i < songlist.length; i++) {
                            this.list.items[len + i] = {
                                name: songlist[i].title.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                                id: songlist[i].song_id,
                                author: songlist[i].author.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                                thumb: "",
                                activeClass: "",
                                progress_id: songlist[i].song_id,
                                updateClass: "show",
                                warningClass: "",
                                waitingClass: "",
                                downloadfinish: false,
                                downloadticket: 0,
                                lyricUrl: "",
                                url: ""
                            
                            }
                        }
                    this.controller.modelChanged(this.model)
                    this.spinnerModel.spinning0 = false;
                    this.controller.modelChanged(this.spinnerModel);
                    this.controller.get('spinnerCont').hide();
                }
                
                
            }
.bind(this)            ,
            onFailure: function(rtn){
                this.spinnerModel.spinning0 = false;
                this.controller.modelChanged(this.spinnerModel);
                this.controller.get('spinnerCont').hide();
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
    }
    else 
        if (this.type == 4) {
            this.list.items = []
            var url
            if (this.type == 1) 
                url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.billboard.billList&type=1&format=json&size=50&offset=" + this.list.items.length
            else 
                if (this.type == 4) {
                    if (this.pages < this.totalpages) {
                        this.pages++;
                        url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.search.common&page_size=50&format=json&query=" + this.content + "&page_no=" + this.pages
                    }
                    else 
                        return;
                }
                else 
                    url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.billboard.billList&type=2&format=json&size=50&offset=" + this.list.items.length
            this.spinnerModel.spinning0 = true;
            this.controller.modelChanged(this.spinnerModel);
            this.controller.get('spinnerCont').show();
            var myAjax = new Ajax.Request(url, {
                method: 'GET',
                onComplete: function(rtn){
                    if (rtn.status == 200) {
                        var info = Mojo.parseJSON(rtn.responseText)
                        var songlist = info.song_list
                        var len = this.list.items.length
                        if (this.type != 4) 
                            for (var i = 0; i < songlist.length; i++) {
                                this.list.items[len + i] = {
                                    name: songlist[i].title,
                                    id: songlist[i].song_id,
                                    author: songlist[i].author,
                                    thumb: songlist[i].pic_big,
                                    activeClass: "",
                                    progress_id: songlist[i].song_id,
                                    updateClass: "show",
                                    warningClass: "",
                                    waitingClass: "",
                                    downloadfinish: false,
                                    downloadticket: 0,
                                    lyricUrl: "",
                                    url: ""
                                
                                }
                            }
                        else 
                            for (var i = 0; i < songlist.length; i++) {
                                this.list.items[len + i] = {
                                    name: songlist[i].title.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                                    id: songlist[i].song_id,
                                    author: songlist[i].author.replace(/<\/em>/g, "").replace(/<em>/g, ""),
                                    thumb: "",
                                    activeClass: "",
                                    progress_id: songlist[i].song_id,
                                    updateClass: "show",
                                    warningClass: "",
                                    waitingClass: "",
                                    downloadfinish: false,
                                    downloadticket: 0,
                                    lyricUrl: "",
                                    url: ""
                                
                                }
                            }
                        this.controller.modelChanged(this.model)
                        this.spinnerModel.spinning0 = false;
                        this.controller.modelChanged(this.spinnerModel);
                        this.controller.get('spinnerCont').hide();
                    }
                    
                    
                }
.bind(this)                ,
                onFailure: function(rtn){
                    this.spinnerModel.spinning0 = false;
                    this.controller.modelChanged(this.spinnerModel);
                    this.controller.get('spinnerCont').hide();
                    this.controller.showAlertDialog({
                        onChoose: function(value){
                        },
                        title: $L("提示"),
                        message: "出错,请稍后重试",
                        choices: [{
                            label: $L('OK'),
                            value: "ok",
                            type: 'affirmative'
                        }]
                    });
                }
.bind(this)
            });
        }
};

SonglistAssistant.prototype.songlistTap = function(event){
    event.stop()
    var element = event.originalEvent.target || event.target
    var item = event.item
    
    
    if (element.hasClassName("update-button")) {
        if (this.downloadStatus) 
            return;
        this.downloadStatus = true
        this.dlItem = item
        var url
        if (islogin && dquality == 2) 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfos&bduss=" + bduss + "&format=json&songid=" + item.id + "&from=android&version=2.4.1"
        else 
            url = "http://tingapi.ting.baidu.com/v1/restserver/ting?method=baidu.ting.song.getInfo&bduss=empty&format=json&songid=" + item.id
        var myAjax = new Ajax.Request(url, {
            method: 'GET',
            onComplete: this.downloadTap,
            onFailure: function(rtn){
                this.controller.showAlertDialog({
                    onChoose: function(value){
                    },
                    title: $L("提示"),
                    message: "出错,请稍后重试",
                    choices: [{
                        label: $L('OK'),
                        value: "ok",
                        type: 'affirmative'
                    }]
                });
            }
.bind(this)
        });
        
    }
    else {
        playlist = this.list;
        playidx = this.model.items.indexOf(item);
        playstatus = 4;
        this.controller.stageController.pushScene("nowplaying", this.title)
    }
    
};

SonglistAssistant.prototype.downloadTap = function(rtn){
    if (rtn.status == 200) {
        var info = Mojo.parseJSON(rtn.responseText)
        var bit = info.songinfo.bitrate.split(",")
        var idx = 0;
        if (bit.length == 1) 
            idx = 0
        else {
            for (var i = bit.length - 1; i > 0; i--) {
                if (parseInt(bit[i]) >= parseInt(bit[i - 1])) {
                    idx = i;
                    break;
                }
                
            }
            
        }
        
        var file_url
        if (islogin && dquality == 2) 
            file_url = info.songurl.url[idx].file_link
        else 
            file_url = info.songurl.url[0].file_link
        
        if (file_url != null) {
            this.dlItem.updateClass = ""
            this.dlItem.waitingClass = "show"
            this.dlItem.activeClass = "active"
            this.dlItem.url = file_url;
            this.dlItem.lyricUrl = info.songinfo.lrclink;
            
            this.controller.modelChanged(this.model)
            this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
                method: 'download',
                parameters: {
                    target: file_url,
                    targetDir: "/media/internal/ting/",
                    targetFilename: info.songinfo.title + "_" + info.songinfo.author + "." + info.songurl.url[0].file_extension,
                    keepFilenameOnRedirect: true,
                    subscribe: true,
                    canHandlePause: true
                },
                onSuccess: this.downloadSuccess,
                onFailure: function(e){
                    this.controller.showAlertDialog({
                        onChoose: function(value){
                        },
                        title: $L("提示"),
                        message: "下载出错",
                        choices: [{
                            label: $L('OK'),
                            value: "ok",
                            type: 'affirmative'
                        }]
                    });
                }
            });
        }
        
        
    }
};


SonglistAssistant.prototype.downloadSuccess = function(resp){
    if (resp.completed) {
        if (resp.completionStatusCode == 200) {
            this.downloadStatus = false;
            this.dlItem.updateClass = ""
            this.dlItem.activeClass = ""
            this.dlItem.waitingClass = ""
            this.dlItem.finishClass = "show"
            this.dlItem.downloadfinish = true;
            this.controller.get(this.dlItem.progress_id).style.width = "0%"
            this.controller.modelChanged(this.model)
            
        }
        
    }
    else 
        if (resp.aborted) {
            this.controller.showAlertDialog({
                onChoose: function(value){
                },
                title: $L("提示"),
                message: "下载中断",
                choices: [{
                    label: $L('OK'),
                    value: "ok",
                    type: 'affirmative'
                }]
            });
        }
        else {
            var index = this.model.items.indexOf(this.dlItem)
            this.dlItem.downloadticket = resp.ticket
            
            this.dlItem.progress = (resp.amountReceived / resp.amountTotal) * 100
            this.controller.get(this.dlItem.progress_id).style.width = (resp.amountReceived / resp.amountTotal) * 100 + "%"
        //this.controller.modelChanged(this.model)
        //this.controller.get('albumlist').mojo.noticeUpdatedItems(index, this.dlItem)
        
        
        }
};

SonglistAssistant.prototype.activate = function(event){
    if (playstatus != 0) 
        this.controller.get('right').show()
};

SonglistAssistant.prototype.deactivate = function(event){
    /* remove any event handlers you added in activate and do any other cleanup that should happen before
     this scene is popped or another scene is pushed on top */
};

SonglistAssistant.prototype.cleanup = function(event){
    /* this function should do any cleanup needed before the scene is destroyed as 
     a result of being popped off the scene stack */
};
